# Author: Jan Vcelak <jvcelak@redhat.com>

class Hints
	def initialize(database)
		@db = database
		setup_schema
	end

	def reveal(player, task, number)
		@db.execute \
			"INSERT INTO hints (player, task, hint) VALUES (?, ?, ?)",
			[player, task, number]
	end

	def number_of_revealed(player, task)
		@db.get_first_value \
			"SELECT COUNT(*) count FROM hints WHERE player = ? AND task = ?",
			[player, task]
	end

	private

	def setup_schema
		@db.execute "CREATE TABLE IF NOT EXISTS hints (
			id INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL,
			created_at DATETIME DEFAULT CURRENT_TIMESTAMP NOT NULL,
			player VARCHAR NOT NULL,
			task VARCHAR NOT NULL,
			hint TINYINT NOT NULL,
			UNIQUE (player, task, hint)
		)"
	end
end
