# Author: Jan Vcelak <jvcelak@redhat.com>

class Players
	def initialize(database)
		@db = database
		setup_schema
	end

	def name(player)
		@db.get_first_value "SELECT name FROM players WHERE player = ?", [player]
	end

	def register(player, name, email)
		@db.execute "INSERT INTO players (player, name, email) VALUES (?, ?, ?)", [player, name, email]
	end

	private

	def setup_schema
		@db.execute "CREATE TABLE IF NOT EXISTS players (
			id INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL,
			created_at DATETIME DEFAULT CURRENT_TIMESTAMP NOT NULL,
			player VARCHAR NOT NULL,
			name VARCHAR NOT NULL,
			email VARCHAR NOT NULL,
			UNIQUE (player)
		)"
	end
end
